#include <m8c.h>        // part specific constants and macros
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules

void RED_LED(void);
void BLUE_LED(void);
void GREEN_LED(void);

void main()
{

 	int iData; 		
 	PWM16_1_Start();								// PWM16 Start
 	M8C_EnableGInt;									// Global Interrupt Enable
   	ADC10_1_Start(ADC10_1_LOWRANGE);				// ADC10 UM Start
//	ADC10_1_iCal(0x22A, ADC10_1_CAL_VBG);  			// use internal reference	
	ADC10_1_iCal(0x3FF, ADC10_1_CAL_P0_7);  		// use external reference
													// if you want to use external reference. please modify adc10xx.asm
													// in function 'ADC10_xxiCal'
													// tst   [X + RefSelect],0h --> tst   [X + RefSelect],80h   
   	ADC10_1_StartADC();								// ADC Start
   	PWM16_1_WritePeriod(341);	
   	while(1){   			
        		while(0 == ADC10_1_fIsDataAvailable());    	
        		iData = ADC10_1_iGetDataClearFlag();    	
				
				if(iData<341)
 				{	
 					PWM16_1_Stop();
 					RED_LED();
 					PWM16_1_WritePulseWidth(iData);
 					PWM16_1_Start();
 				}
 				
 				if(iData>341 && iData <682)
 				{
 				 	
 					PWM16_1_Stop();
 					GREEN_LED();
 					PWM16_1_WritePulseWidth(iData-341);
 					PWM16_1_Start();
 
 				}
 				
 				if(iData>682)
 				{
 				 	
 					PWM16_1_Stop();
 					BLUE_LED();
 					PWM16_1_WritePulseWidth(iData-682);
 					PWM16_1_Start();
 
 				}

 		}
}

	void RED_LED(void)				//connect to Red LED 
	{
	 	DCB02CR0 = 0x00;
	 	DCB02OU &= 0xF8;
		DCB02OU |= 0x07;  
		DCB02CR0 = 0x01;
		PRT1GS = 0x08;
	}
	
	void BLUE_LED(void)				//connect to Blue LED 
	{
	 	DCB02CR0 = 0x00;
	 	DCB02OU &= 0xF8;
		DCB02OU |= 0x06;  
		DCB02CR0 = 0x01;
		PRT1GS = 0x04;
	}
	
	void GREEN_LED(void)			//connect to Green LED 
	{
	 	DCB02CR0 = 0x00;
	 	DCB02OU &= 0xF8;
		DCB02OU |= 0x04;  
		DCB02CR0 = 0x01;
		PRT1GS = 0x10;
	}
	
