#include <m8c.h>        // part specific constants and macros
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules
#include <math.h>
#include <stdlib.h>

float iData_to_Temp(float iData);

float A=0.00129655;
float B=0.000207527;
float C=0.000000177563;

	void main()
	{
	 	int iData; 												// AD buffer
	 	float Result;											// temperature buffer	
	 	///UM Configration///			
	 	M8C_EnableGInt;    			
	   	ADC10_1_Start(ADC10_1_LOWRANGE);     	
	   	ADC10_1_iCal(0x22A, ADC10_1_CAL_VBG);  					// use internal reference	
//	   	ADC10_1_iCal(0x3FF, ADC10_1_CAL_P0_7);  				// use external reference
																// if you want to use external reference. please modify adc10xx.asm
																// in function 'ADC10_xxiCal'
																// tst   [X + RefSelect],0h --> tst   [X + RefSelect],80h   

	   	ADC10_1_StartADC();     
	   	TX8_Start(TX8_PARITY_NONE);  
	   	          			
	   	while(1){   
					while(0 == ADC10_1_fIsDataAvailable());    
			        iData = ADC10_1_iGetDataClearFlag();  
					Result=iData_to_Temp(iData);				// calc temperature
					TX8_CPutString("\r\n");
					TX8_CPutString("Temperature=");
					TX8_PutString(ftoa(Result,0));				// output temperature 
					TX8_CPutString("[K]\r\n");
		 		}
	}
	//calc temperature//
	float iData_to_Temp(float iData)
	{	
			float T,R;

	 		R=(iData*10000.0)/(1023-iData);		
	 		T=(float)1.0/(A+(B)*log(R)+C*(log(R))*(log(R))*(log(R)));
	 		return T;
	}