#include <m8c.h>        // part specific constants and macros
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules
#include <stdlib.h>
#include "ADCLookUpTable.h"

int iADCtoTemp(int iTb);

void main()
{

 	int iData,iTemperature; 	// thermistor temperature ; 		
 	float Result;		
 	char *convert_temp;
 	M8C_EnableGInt;    			
   	ADC10_1_Start(ADC10_1_FULLRANGE);     	
	ADC10_1_iCal(0x22A, ADC10_1_CAL_VBG);  					// use internal reference	
//	ADC10_1_iCal(0x3FF, ADC10_1_CAL_P0_7);  				// use external reference
															// if you want to use external reference. please modify or check adc10xx.asm
															// in function 'ADC10_xxiCal'
															// tst   [X + RefSelect],0h --> tst   [X + RefSelect],80h   
   	ADC10_1_StartADC();     
   	TX8_Start(TX8_PARITY_NONE);            			
   	
	   	while(1){   
					while(0 == ADC10_1_fIsDataAvailable());    
			        iData = ADC10_1_iGetDataClearFlag();  
					iTemperature = iADCtoTemp(iData); 					// call look up table
					itoa(convert_temp,iTemperature,10);					// int to ascii
					TX8_CPutString("\r\n");
					TX8_CPutString("Temperature=");
					TX8_PutString(convert_temp);
					TX8_CPutString("[C]\r\n");
		 		}
}



int iADCtoTemp(int iTb)
{
	int i, iTemperature, iDistance, iMinDistance, iIndex;     
	iMinDistance = abs(ResistanceLookupTable[0]-iTb);
	iIndex = 0;
	// find position (iIndex) in temperature lookup table 
    // where the value is nearest to measured 	
    for (i = 0; i < LOOKUP_TABLE_SIZE; i++) 
	{
		iDistance = abs(ResistanceLookupTable[i] - iTb);
		if (iDistance <= iMinDistance)
		{
			iMinDistance = iDistance;
			iIndex = i;
		}
    }        
    // the real temperature value is:  
    iTemperature = iIndex * TEMP_STEP  + TEMP_MIN_VALUE;
    return iTemperature;
}