	cpu LMM
	.module main.c
	.area text(rom, con, rel)
	.dbfile ./main.c
	.dbfunc e main _main fV
;         Result -> X+6
;   convert_temp -> X+4
;   iTemperature -> X+2
;          iData -> X+0
_main::
	.dbline -1
	push X
	mov X,SP
	add SP,10
	.dbline 9
; #include <m8c.h>        // part specific constants and macros
; #include "PSoCAPI.h"    // PSoC API definitions for all User Modules
; #include <stdlib.h>
; #include "ADCLookUpTable.h"
; 
; int iADCtoTemp(int iTb);
; 
; void main()
; {
	.dbline 14
; 
;  	int iData,iTemperature; 	// thermistor temperature ; 		
;  	float Result;		
;  	char *convert_temp;
;  	M8C_EnableGInt;    			
		or  F, 01h

	.dbline 15
;    	ADC10_1_Start(ADC10_1_FULLRANGE);     	
	push X
	mov A,3
	xcall _ADC10_1_Start
	.dbline 16
; 	ADC10_1_iCal(0x22A, ADC10_1_CAL_VBG);  					// use internal reference	
	mov A,3
	push A
	mov A,2
	push A
	mov A,42
	push A
	xcall _ADC10_1_iCal
	mov REG[0xd0],>__r0
	add SP,-3
	.dbline 21
; //	ADC10_1_iCal(0x3FF, ADC10_1_CAL_P0_7);  				// use external reference
; 															// if you want to use external reference. please modify or check adc10xx.asm
; 															// in function 'ADC10_xxiCal'
; 															// tst   [X + RefSelect],0h --> tst   [X + RefSelect],80h   
;    	ADC10_1_StartADC();     
	xcall _ADC10_1_StartADC
	.dbline 22
;    	TX8_Start(TX8_PARITY_NONE);            			
	mov A,0
	xcall _TX8_Start
	pop X
	xjmp L3
X0:
	.dbline 24
;    	
; 	   	while(1){   
L5:
	.dbline 25
L6:
	.dbline 25
	push X
	xcall _ADC10_1_fIsDataAvailable
	mov REG[0xd0],>__r0
	pop X
	cmp A,0
	jz L5
	.dbline 26
	push X
	xcall _ADC10_1_iGetDataClearFlag
	mov REG[0xd0],>__r0
	mov [__r0],X
	pop X
	mov [X+1],A
	mov A,[__r0]
	mov [X+0],A
	.dbline 27
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	xcall _iADCtoTemp
	mov REG[0xd0],>__r0
	mov A,[__r1]
	mov [X+3],A
	mov A,[__r0]
	mov [X+2],A
	.dbline 28
	mov A,0
	push A
	mov A,10
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	mov A,[X+4]
	push A
	mov A,[X+5]
	push A
	xcall _itoa
	add SP,-8
	.dbline 29
	push X
	mov A,>L8
	push A
	mov A,<L8
	mov X,A
	pop A
	xcall _TX8_CPutString
	.dbline 30
	mov A,>L9
	push A
	mov A,<L9
	mov X,A
	pop A
	xcall _TX8_CPutString
	pop X
	.dbline 31
	push X
	mov A,[X+4]
	push A
	mov A,[X+5]
	mov X,A
	pop A
	xcall _TX8_PutString
	.dbline 32
	mov A,>L10
	push A
	mov A,<L10
	mov X,A
	pop A
	xcall _TX8_CPutString
	pop X
	.dbline 33
L3:
	.dbline 24
	xjmp L6
X1:
	.dbline -2
	.dbline 34
; 					while(0 == ADC10_1_fIsDataAvailable());    
; 			        iData = ADC10_1_iGetDataClearFlag();  
; 					iTemperature = iADCtoTemp(iData); 					// call look up table
; 					itoa(convert_temp,iTemperature,10);					// int to ascii
; 					TX8_CPutString("\r\n");
; 					TX8_CPutString("Temperature=");
; 					TX8_PutString(convert_temp);
; 					TX8_CPutString("[C]\r\n");
; 		 		}
; }
L1:
	add SP,-10
	pop X
	.dbline 0 ; func end
	jmp .
	.dbsym l Result 6 D
	.dbsym l convert_temp 4 pc
	.dbsym l iTemperature 2 I
	.dbsym l iData 0 I
	.dbend
	.dbfunc e iADCtoTemp _iADCtoTemp fI
;   iTemperature -> X+8
;         iIndex -> X+6
;   iMinDistance -> X+4
;      iDistance -> X+2
;              i -> X+0
;            iTb -> X-5
_iADCtoTemp::
	.dbline -1
	push X
	mov X,SP
	add SP,10
	.dbline 39
; 
; 
; 
; int iADCtoTemp(int iTb)
; {
	.dbline 41
; 	int i, iTemperature, iDistance, iMinDistance, iIndex;     
; 	iMinDistance = abs(ResistanceLookupTable[0]-iTb);
	mov REG[0xd0],>__r0
	mov A,>_ResistanceLookupTable
	push X
	push A
	mov X,<_ResistanceLookupTable
	romx
	mov [__r0],A
	pop A
	inc X
	adc A,0
	romx
	mov [__r1],A
	pop X
	mov A,[X-4]
	sub [__r1],A
	mov A,[X-5]
	sbb [__r0],A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	xcall _abs
	add SP,-2
	mov REG[0xd0],>__r0
	mov A,[__r1]
	mov [X+5],A
	mov A,[__r0]
	mov [X+4],A
	.dbline 42
; 	iIndex = 0;
	mov [X+7],0
	mov [X+6],0
	.dbline 45
; 	// find position (iIndex) in temperature lookup table 
;     // where the value is nearest to measured 	
;     for (i = 0; i < LOOKUP_TABLE_SIZE; i++) 
	mov [X+1],0
	mov [X+0],0
L12:
	.dbline 46
; 	{
	.dbline 47
; 		iDistance = abs(ResistanceLookupTable[i] - iTb);
	mov REG[0xd0],>__r0
	mov A,[X+1]
	mov [__r1],A
	mov A,[X+0]
	mov [__r0],A
	asl [__r1]
	rlc [__r0]
	add [__r1],<_ResistanceLookupTable
	adc [__r0],>_ResistanceLookupTable
	mov A,[__r0]
	push X
	push A
	mov X,[__r1]
	romx
	mov [__r0],A
	pop A
	inc X
	adc A,0
	romx
	mov [__r1],A
	pop X
	mov A,[X-4]
	sub [__r1],A
	mov A,[X-5]
	sbb [__r0],A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	xcall _abs
	add SP,-2
	mov REG[0xd0],>__r0
	mov A,[__r1]
	mov [X+3],A
	mov A,[__r0]
	mov [X+2],A
	.dbline 48
; 		if (iDistance <= iMinDistance)
	mov A,[X+5]
	sub A,[X+3]
	mov A,[X+2]
	xor A,-128
	mov [__rX],A
	mov A,[X+4]
	xor A,-128
	sbb A,[__rX]
	jc L16
X2:
	.dbline 49
; 		{
	.dbline 50
; 			iMinDistance = iDistance;
	mov A,[X+3]
	mov [X+5],A
	mov A,[X+2]
	mov [X+4],A
	.dbline 51
; 			iIndex = i;
	mov A,[X+1]
	mov [X+7],A
	mov A,[X+0]
	mov [X+6],A
	.dbline 52
; 		}
L16:
	.dbline 53
L13:
	.dbline 45
	inc [X+1]
	adc [X+0],0
	.dbline 45
	mov A,[X+1]
	sub A,-65
	mov A,[X+0]
	xor A,-128
	sbb A,(0 ^ 0x80)
	jc L12
X3:
	.dbline 55
;     }        
;     // the real temperature value is:  
;     iTemperature = iIndex * TEMP_STEP  + TEMP_MIN_VALUE;
	mov REG[0xd0],>__r0
	mov A,[X+6]
	push A
	mov A,[X+7]
	push A
	mov A,0
	push A
	mov A,1
	push A
	xcall __mul16
	add SP,-4
	mov A,[__rX]
	mov [__r1],A
	mov A,[__rY]
	mov [__r0],A
	mov A,[__r1]
	add A,-40
	mov [X+9],A
	mov A,[__r0]
	adc A,-1
	mov [X+8],A
	.dbline 56
;     return iTemperature;
	mov A,[X+9]
	mov [__r1],A
	mov A,[X+8]
	mov [__r0],A
	.dbline -2
L11:
	add SP,-10
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l iTemperature 8 I
	.dbsym l iIndex 6 I
	.dbsym l iMinDistance 4 I
	.dbsym l iDistance 2 I
	.dbsym l i 0 I
	.dbsym l iTb -5 I
	.dbend
	.area lit(rom, con, rel)
L10:
	.byte 91,'C,93,13,10,0
L9:
	.byte 'T,'e,'m,'p,'e,'r,'a,'t,'u,'r,'e,61,0
L8:
	.byte 13,10,0
